#include <vector>
#include <list>
#include <map>
#include <set>
#include <algorithm>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <string>
#include <queue>

#define vi vector <int>
#define vl vector <long long>
#define vpii vector <pair <int,int> >
#define mp(x,y) make_pair(x,y)
#define all(x) (x).begin(),(x).end()
#define sz(x) (int)(x).size()
#define FOR(i,n) for(ll i=0;i<int(n);i++)
#define READ(v,n) {FOR(i,n){ll x;cin>>x;v.pb(x);} }
#define gmin(a,b) {if (b<a) a=b;}
#define gmax(a,b) {if (b>a) a=b;}
#define pb push_back
#define ppb pop_back
typedef long long ll;
typedef unsigned long long ull;
using namespace std;

vpii points;
vpii lenv, renv;

bool checkConvex(pair<int,int> p1, pair<int,int> p2, pair<int,int> p3, int sign){
  int u1 = p2.first-p1.first;
  int u2 = p2.second-p1.second;
  int v1 = p3.first-p2.first;
  int v2 = p3.second-p2.second;
  return (sign*(u1*v2-u2*v1) >=0);
}

bool delLeft(){
  int p3 = lenv.size()-1;
  int p2 = p3-1;
  int p1 = p2-1;
  if(!checkConvex(lenv[p1], lenv[p2], lenv[p3], -1)){
    lenv.erase(lenv.end()-2);
    return true;
  }
  return false;
}

bool delRight(){
  int p3 = renv.size()-1;
  int p2 = p3-1;
  int p1 = p2-1;
  if(!checkConvex(renv[p1], renv[p2], renv[p3], 1)){
    renv.erase(renv.end()-2);
    return true;
  }
  return false;
}

bool pt_cmp(pair<int,int> a, pair<int,int> b){
    pair<int,int> p1 = a;
    pair<int,int> p2 = b;
    if(p1.second != p2.second) return (p1.second < p2.second);
    return (p1.first < p2.first);
}

int main(){
  int n;
  while(cin>>n){
    lenv.clear();
    renv.clear();
    points.clear();
    int x,y;
    FOR(i,n){
      cin>>x>>y;
      points.push_back(mp(x,y));
    }
    sort(all(points), pt_cmp);
    
    lenv.push_back(points.front());
    renv.push_back(points.front());
    for(ll i=1;i<int(n);i++){
      lenv.push_back(points[i]);
      renv.push_back(points[i]);
      while(lenv.size()>2 && delLeft());
      while(renv.size()>2 && delRight());
    }
    printf("L\n");
    FOR(i,lenv.size()){
      printf("%d %d\n", lenv[i].first, lenv[i].second);
    }
    printf("R\n");
    FOR(i,renv.size()){
      printf("%d %d\n", renv[i].first, renv[i].second);
    }
  }
  
  end:
  return 0;
}


